/************************************************************
*
*     images classificator 
*
*     FILE : classificator.cpp
*  CREATED : 20.02.2003
*       OS : FreeBSD 4.6
* COMPILER : GNU project C and C++ Compiler (gcc-2.95.3)
*
*************************************************************
*
*  Copyright (C) Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://mechanoid.narod.ru
*  e-mail : periodical@ukrpost.net
* 
************************************************************/
#include <iostream.h>
#include <stdlib.h>
#include "classificator.h"

/**********************************************/
Classificator::Classificator():Perceptron(IN,OUT)
{
}

/**********************************************/
Classificator::~Classificator()
{
}

/**********************************************/
void Classificator::set(uint n)
{
   if(n>(N-1)){ return;}
   
   for(uint j=0;j<Y;j++)
   {
	  for(uint i=0;i<X;i++)
	  {
		 m_X[i+j*X]=(PATTERNS[n][j][i]==MARK)?HI:LO;
	  }
   }
   
   for(uint j=0;j<OUT;j++){ m_YI[j]=TARGET[n][j]; }
}

/**********************************************/
void Classificator::teach()
{
   uint n=0;
   uint m=0;
   uint iter=0; 
   weight_t err=0.0;  
	   
   for(iter=0;iter<MAX_ITER;iter++) 
   {
	  err=0.0;

	  for(n=0;n<N;n++) 
	  {
		 set(n);
		 step();
		 outError();
		 err=(m_err>err)?m_err:err; //max error
	  }

	  if(err<=ERR){break;}
		 
	  for(m=0;m<N*10;m++) 
	  {
		 // random from [0,N-1]
		 n=(uint)(((float)rand()/RAND_MAX)*(N));
		 set(n);
		 step();
		 outError();
		 Perceptron::teach();
	  }
   }
}
/**********************************************/
void Classificator::printIn()
{
   for(uint j=0;j<Y;j++)
   {
	  for(uint i=0;i<X;i++)
	  {
		 cout<<((m_X[j*X+i]==HI)?MARK:NOMARK);
	  }
	  cout<<endl;
   }
}

/**********************************************/
void Classificator::printOut()
{
   uint j=0;

   for(j=0;j<OUT;j++)
   {
	  if(m_Y[j]==HI)
	  {
		 cout<<j<<endl;
		 return;
	  }
   }
   cout<<"unknown\n";
}
