/************************************************************
*
*    one layer neural net 
* 
*     FILE : nnet.cpp
*  CREATED : 20.02.2003
*       OS : FreeBSD 4.6
* COMPILER : GNU project C and C++ Compiler (gcc-2.95.3)
*
*************************************************************
*
*  Copyright (C) Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://mechanoid.narod.ru
*  e-mail : periodical@ukrpost.net
* 
************************************************************/
#include <iostream.h>
#include <stdlib.h>

#include "nnet.h"

/**********************************************/
NNet::NNet(uint in_size, uint out_size): m_x(in_size), m_y(out_size)
{
	 m_X=new data_t[in_size];
	 m_S=new weight_t[out_size];
	 m_Y=new data_t[out_size];

	 /////////////////////////////
	 // make weight matrix m_W
	  
	 // if((m_W=(weight_t**) new weight_t*[out_size])==NULL){return; }
	 m_W=(weight_t**) new weight_t*[out_size];
	 
	 if(m_W==NULL){return; }
	 
	 for(uint i=0;i<out_size;i++)
	 {
		m_W[i]=(weight_t*) new weight_t[in_size];
	 }
	 
	 initWeight();
	 //
	 /////////////////////////////
}

/*****************************/
void NNet::initWeight()
{
   srand(4711);

   for(uint j=0;j<m_y;j++)
   {   
	  for(uint i=0;i<m_y;i++)
	  {	
		 m_W[j][i]=sin(rand())/2.0;
	  }
   }
}

/**********************************************/
NNet::~NNet()
{
	if(m_Y) { delete m_Y; }
	if(m_S) { delete m_S; }
	if(m_X) { delete m_X; }
	if(m_W) { delete [] m_W; }
}

/*****************************/
void NNet::set(data_t *in)
{
   memcpy(m_X,in,m_x);
}

/**********************************************/
void NNet::step()
{
	for(uint i=0;i<m_y;i++) 
	{
	   m_S[i]=s(i); 
	   m_Y[i]=f(m_S[i]); 
	}
}

/*****************************/
void NNet::printWeight()
{
	cout<<"----------- W ------------\n";
	for(uint j=0;j<m_y;j++)	
	{
	   for(uint i=0;i<m_x;i++)
	   {
		  cout<<m_W[j][i]<<" "; 
	   }
	   cout<<endl;
	}
	cout<<"--------------------------\n";
}

/*****************************/
void NNet::printOut()
{
   cout<<" Y => ";
   for(uint i=0;i<m_y;i++)	
   {
	  cout<<(int)m_Y[i]<<' ';
   }
   cout<<endl;
}

/*****************************/
void NNet::printIn()
{
   cout<<" X => ";
   for(uint i=0;i<m_x;i++)	
   {
	  cout<<(int)m_X[i]<<' ';
   }
   cout<<endl;
}

