/************************************************************
*    one layer neural net 
* 
*     FILE : nnet.h
*  CREATED : 20.02.2003
*       OS : FreeBSD 4.6
* COMPILER : GNU project C and C++ Compiler (gcc-2.95.3)
*
*************************************************************
*
*  Copyright (C) Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://mechanoid.narod.ru
*  e-mail : periodical@ukrpost.net
* 
************************************************************/
#ifndef NNET_H
#define NNET_H

////////////////////////////////////////
typedef unsigned int  uint;
typedef double        weight_t;
typedef char          data_t;

////////////////////////////////////////
class NNet
{
public:
	NNet(uint in_size, uint out_size);
	virtual ~NNet();
	
	void set(data_t* in);
	void step();
	
    void printWeight();
	virtual void printOut();
	virtual void printIn();
	
protected:

	void initWeight();

	virtual data_t   f(weight_t s)=0;
    virtual weight_t s(uint i)=0;

	uint       m_x; // inputs count
	uint       m_y; // outputs count
	
	data_t*    m_X; // inputs  
	weight_t*  m_S; // states 
	data_t*    m_Y; // outputs 

    weight_t** m_W; // weight matrix
};

#endif
