/************************************************************
*
*     patterns for classificator 
*
*     FILE : patterns.h 
*  CREATED : 20.02.2003
*       OS : FreeBSD 4.6
* COMPILER : GNU project C and C++ Compiler (gcc-2.95.3)
*
*************************************************************
*
*  Copyright (C) Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://mechanoid.narod.ru
*  e-mail : periodical@ukrpost.net
* 
************************************************************/
#ifndef PATTERNS_H
#define PATTERNS_H

const data_t MARK='O';
const data_t NOMARK='.';

const uint X=5; // pattern size X Y
const uint Y=7;
const uint N=10; // patterns number

const uint IN=X*Y; // inputs number of net 
const uint OUT=10; // outputs number of net 

///////////////////////////////////

const data_t PATTERNS[N][Y][X+1] = 
{{  ".OOO.",
    "O...O",
    "O...O",
    "O...O",
    "O...O",
    "O...O",
    ".OOO."  },

 {  "..O..",
    ".OO..",
    "O.O..",
    "..O..",
    "..O..",
    "..O..",
    "..O.."  },

 {  ".OOO.",
    "O...O",
    "....O",
    "...O.",
    "..O..",
    ".O...",
    "OOOOO"  },

 {  ".OOO.",
    "O...O",
    "....O",
    ".OOO.",
    "....O",
    "O...O",
    ".OOO."  },

 {  "...O.",
    "..OO.",
    ".O.O.",
    "O..O.",
    "OOOOO",
    "...O.",
    "...O."  },

 {  "OOOOO",
    "O....",
    "O....",
    "OOOO.",
    "....O",
    "O...O",
    ".OOO."  },

 {  ".OOO.",
    "O...O",
    "O....",
    "OOOO.",
    "O...O",
    "O...O",
    ".OOO."  },

 {  "OOOOO",
    "....O",
    "....O",
    "...O.",
    "..O..",
    ".O...",
    "O...."  },

 {  ".OOO.",
    "O...O",
    "O...O",
    ".OOO.",
    "O...O",
    "O...O",
    ".OOO."  },

 {  ".OOO.",
    "O...O",
    "O...O",
    ".OOOO",
    "....O",
    "O...O",
    ".OOO."  }};


///////////////////////////////////

const data_t TARGET[N][OUT] = 
{
   {HI,LO,LO,LO,LO,LO,LO,LO,LO,LO},
   {LO,HI,LO,LO,LO,LO,LO,LO,LO,LO},
   {LO,LO,HI,LO,LO,LO,LO,LO,LO,LO},
   {LO,LO,LO,HI,LO,LO,LO,LO,LO,LO},
   {LO,LO,LO,LO,HI,LO,LO,LO,LO,LO},
   {LO,LO,LO,LO,LO,HI,LO,LO,LO,LO},
   {LO,LO,LO,LO,LO,LO,HI,LO,LO,LO},
   {LO,LO,LO,LO,LO,LO,LO,HI,LO,LO},
   {LO,LO,LO,LO,LO,LO,LO,LO,HI,LO},
   {LO,LO,LO,LO,LO,LO,LO,LO,LO,HI}
};

#endif
