/************************************************************
*
*     the perceptron neural net
*
*     FILE : perceptron.cpp
*  CREATED : 20.02.2003
*       OS : FreeBSD 4.6
* COMPILER : GNU project C and C++ Compiler (gcc-2.95.3)
*
*************************************************************
*
*  Copyright (C) Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://mechanoid.narod.ru
*  e-mail : periodical@ukrpost.net
* 
************************************************************/
#include <iostream.h>
#include <stdlib.h>
#include "perceptron.h"

/**********************************************/
Perceptron::Perceptron(uint in_size, uint out_size):
               NNet(in_size,out_size),m_err(0)

{
   m_YI=new data_t[out_size];
   m_E=new weight_t[out_size];
}

/**********************************************/
Perceptron::~Perceptron()
{
   if(m_YI) { delete m_YI; }
   if(m_E)  { delete m_E;  }
}

/**********************************************/
// activation func 
data_t Perceptron::f(weight_t s)
{
   return (s<T)?LO:HI; 
}

/**********************************************/
// state of neuron j 
weight_t Perceptron::s(uint j)
{
	weight_t sum=0;

	for(uint i=0;i<m_x;i++)	{ sum+=m_X[i]*m_W[j][i]; }
	
	return sum;
}

/*****************************/
void Perceptron::teach()
{
	for(uint j=0; j<m_y; j++)
	{
	   for(uint i=0 ; i<m_x ; i++)
	   {
		  m_W[j][i]+= ETA*m_X[i]*m_E[j]; 
	   }
	}
}

/*****************************/
void Perceptron::outError()
{
   m_err=0.0;
   
   for(uint j=0;j<m_y;j++)
   {
	  m_E[j]=m_YI[j]-m_S[j];
	  m_err+=0.5*(m_E[j]*m_E[j]);
   }
}

