/************************************************************
*
*     the perceptron neural net
*
*     FILE : perceptron.h
*  CREATED : 20.02.2003
*       OS : FreeBSD 4.6
* COMPILER : GNU project C and C++ Compiler (gcc-2.95.3)
*
*************************************************************
*
*  Copyright (C) Evgeny S. Borisov
*
*  Glushkov Institute of Cybernetics
*  National Academy of Sciences of Ukraine
* 
*    http://mechanoid.narod.ru
*  e-mail : periodical@ukrpost.net
* 
************************************************************/
#ifndef PERCEPTRON_H
#define PERCEPTRON_H

#include "nnet.h"

////////////////////////////////////////
const data_t LO=-1;
const data_t HI=+1;
const data_t T=0;

const weight_t ETA=0.001; // teching speed

///////////////////////////////////////
class Perceptron: public NNet
{
public:
   Perceptron(uint in_size, uint out_size);
   virtual ~Perceptron();

   virtual void teach();
	
protected:
   virtual data_t   f(weight_t s);
   virtual weight_t s(uint i);
   
   void Perceptron::outError();
   
   data_t* m_YI; // ideal out for teaching
   weight_t* m_E;  // error vector of output layer
   weight_t m_err; // error of net
};

#endif
